%% Problem 2b
% INPUT 
% p1, q1 - Vectors specifying G_1
% p2, q2 - Vectors specifying G_2
% OUTPUT
% s,t  - Vectors specifying the angle bisector

function [s, t] = Problem2b(p1, q1, p2, q2)

% We first check the special cases, in which there might be no solutions
if isequal(q1/norm(q1), q2/norm(q1) )
    if isequal(p1, p2)
        % If G_1 and G_2 are the same line
        disp('These lines are the same');
        s = p1;
        t= q1;
    else
        % If there is no solution
        disp('The lines are parallel and they do not intersect');
        s=[];
        t=[];
    end
    return
end

% Determine the intersection of G_1 and G_2
A = [ q1, -q2];
Coeffs = A\ ( (p2-p1));
s = p1+Coeffs(1)*q1;

% Determine the orientation parameters of both bisectors (they have the same
% translation parameter, i.e. the intersection of G_1 and G_2).

t = q1/norm(q1)+q2/norm(q2);

% Plotting
% When plotting the lines we will transform them from the parametric mode
% i.e. from        p + t *q = v, where p, q and v are vectors
% to the slope-intercept mode, i.e. to      y=a*x + b

% First determine the range of x. Remember that every line is determined by
% exactly two points.
x = [s(1)-5; s(1)+5];

% Plot the first line
% Compute the y-axis values first
yFirst = x*q1(2)/q1(1)-q1(2)*p1(1)/q1(1)+p1(2);

plot(x, yFirst, 'r-');
hold on;
% Plot the second line
% Compute the y-axis values for the second line
ySecond = x*q2(2)/q2(1)-q2(2)*p2(1)/q2(1)+p2(2);
plot(x, ySecond, 'g-');

% Plot the intersection of G_1 and G_2
plot(s(1),s(2), 'bo', 'LineWidth', 2);

% Plot the bisector
% Again, compute the y-axis values for the first bisector
yBisector = x*t(2)/t(1)-t(2)*s(1)/t(1)+s(2);
plot(x, yBisector, 'k--');

axis equal
legend('Line G_1', 'Line G_2', 'Point of intersection','Angle bisector');
title('Problem 2(b)');


end
