%% Problem 3
% INPUT
% r - radius of the circle
% centre - centre of the circle. A two dimensional vector
% p, q - vectors specifying the line G
% OUTPUT
% intersection - intersection of the circle and the vector

function intersection = Problem3(r, centre, p, q)

% Coefficients for the governing quadratic polynomial, which suit the
% form the function zerosquadpol expects.
alpha = (2*(q(1)*(p(1)-centre(1))+q(2)*(p(2)-centre(2)) )) / norm(q, 2)^2;
beta = ((p(1)-centre(1))^2+(p(2)-centre(2))^2-r^2) / norm(q, 2)^2;

% The roots can then be computed by
tau = zerosquadpolstab(alpha, beta);

% The case when intersections exist
if isempty(tau) == 0
   
    intersection = p+q*tau(1);
    
    % Plotting
    % Plot the circle
    phi = 0:pi/50:2*pi;
    x = r * cos(phi) + centre(1);
    y = r * sin(phi) + centre(2);
    plot(x, y,'k');
    axis equal
    hold on
    
    % Plot the line G
    % Compute the y-axis values first
    x = [intersection(1)-5; intersection(2)+5];
    y = x*q(2)/q(1)-q(2)*p(1)/q(1)+p(2);
    plot(x, y, 'b--');
    
    % Plot the intersection
    plot(intersection(1), intersection(2), 'ro', 'LineWidth', 1.5);
    
    legend('The circle C', 'Line G', 'Intersection');

% The case when intersection does not exist
else
    intersection = [];
    disp('There are no solutions');

    % Plotting
    % Plot the circle
    phi = 0:pi/50:2*pi;
    x = r * cos(phi) + centre(1);
    y = r * sin(phi) + centre(2);
    plot(x, y, 'k');
    axis equal
    hold on
    
    % Plot the line G    
    x = [centre(1)-2*r; centre(1)+2*r];
    y = x*q(2)/q(1)-q(2)*p(1)/q(1)+p(2);
    plot(x, y, 'b--');
    legend('The circle C', 'Line G');
    
end


