%% Problem 4
% INPUT
% a, b - Distinct points in R^2
% p, q - vectors specifying a line G
% OUTPUT
% reflectionLines - lines of reflection

function [s, t] = Problem4(a, b, p, q)

% Calculate the vector specifying the line ab
qab = b-a;
% Compute the point of intersection and the bisector 
[intersection , bisector] = Problem2bNoPlot(a, qab, p, q);
t = bisector;
s = intersection;

% Plotting
figure

xmin = min([a(1) b(1) intersection(1)]);
xmax = max([a(1) b(1) intersection(1)]);
x = [xmin-2; xmax+2];
y = x*q(2)/q(1)-q(2)*p(1)/q(1)+p(2);

% Plot Line G
plot(x, y, 'r');
axis equal
hold on

% Plot the line going through a and b
yab = x*qab(2)/qab(1)-qab(2)*a(1)/qab(1)+a(2);
plot(x, yab, 'k');

% Plotting the points
plot(intersection(1), intersection(2),'bo','LineWidth',1.5);
plot(a(1), a(2),'b*','LineWidth',1.5);
plot(b(1), b(2),'b+','LineWidth',1.5);

% Plot the line of reflection

yReflectionLIne=x*t(2)/t(1)-t(2)*intersection(1)/t(1)+intersection(2);
plot(x, yReflectionLIne, 'g--');

% Plot the reflected points
aReflected=Problem2aNoPlot(a, intersection, t);
bReflected=Problem2aNoPlot(b, intersection, t);

plot(aReflected(1), aReflected(2),'r*','LineWidth',1.5);
plot(bReflected(1), bReflected(2),'r+','LineWidth',1.5);

plot([aReflected(1); a(1)],[aReflected(2); a(2)],'k--');
plot([bReflected(1); b(1)],[bReflected(2); b(2)],'k--');

legend('The line G','Line connecting a and b', 'Intersection','Point a',...
    'Point b', 'Line of reflection', 'Reflection of a','Reflection of b');
end


% We use the function Problem 2b, but without plotting
function [s, t] = Problem2bNoPlot(p1, q1, p2, q2)

% We first check the special cases, in which there might be no solutions
if isequal(q1/norm(q1), q2/norm(q2))
    if isequal(p1, p2)
        % If G_1 and G_2 are the same line
        disp('These lines are the same');
        s = p1;
        t= q1;
    else
        % If there is no solution
        disp('The lines are parallel and they do not intersect');
        s=[];
        t=[];
    end
    return
end

% Determine the intersection of G_1 and G_2
A = [q1, -q2];
Coeffs = A \ ( (p2-p1));
s = p1 + Coeffs(1)*q1;

% Determine the orientation parameter of the bisector

t = q1/norm(q1)+q2/norm(q2);
end

% We use the function Problem 2a, but without plotting
function aReflect = Problem2aNoPlot(a, p, q)

alpha = dot(a-p,q)/(dot(q,q));
aReflect = 2*(p+q*alpha) - a;

end